var PointsRegistrator = Class.extend({
	init: function(FunctionRegistrator, function_name, points, bar) {
	
		this.FunctionRegistrator = FunctionRegistrator;
		this.FunctionRegistrator.register(this.addPoints, function_name, this);

		this.indexes = [];
		this.points = [];
		this.categories = [];
		this.current = 0;
		this.total = points;
		this.sum = this.total["_sum_"].max;
		
		for (cat in this.total)
			this.total[cat] = this.total[cat].max;
		
		if (!(typeof bar === "undefined")) {
			this.bar = bar;
		}
	},
	
	addPoints: function(category, points, node) {
		var idx = this.indexes.indexOf(node);
		
		if (idx == -1) {
			this.indexes.push(node);
			this.categories.push([]);
			this.points.push([]);
			
			idx = this.indexes.length - 1;
			
			this.categories[idx].push(category);
			this.points[idx].push(points);
			this.current += points;
		} else {
			if (this.categories[idx].indexOf(category) == -1) {
				this.categories[idx].push(category);
				this.points[idx].push(points);
				this.current += points;
			}
		}
		
		this.updateProgressBar();
	},
	
	getProgress: function() {
		if (this.sum == 0)
			return 100;
		return this.current / this.sum * 100;
	},
	
	getDetails: function() {
		var cats = [];
		var pts = [];
		
		for (var i = 0;i < this.indexes.length;i++) {
			for (var j = 0;j < this.categories[i].length;j++) {
				var cat = this.categories[i][j];
				var pt = this.points[i][j];
				
				var idx = cats.indexOf(cat);
				
				if (idx > -1) {
					pts[idx] += pt;
				} else {
					cats.push(cat);
					pts.push(pt);
				}
			}
		}
		
		for (cat in this.total) {
			if (cat == "_sum_")
				continue;
			if (cats.indexOf(cat) == -1) {
				cats.push(cat);
				pts.push(0);
			}
		}
		
		return {"categories" : cats, "points" : pts};
	},
	
	updateProgressBar: function() {
		if (!(typeof this.bar === "undefined") && this.bar != null) {
			var progress = this.getProgress();
			this.bar.text(Math.round(progress) + "%");
			progress = progress.toString() + "%";
			this.bar.css("width", progress);
		}
	}
});
